/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 *********************************************************************/

#pragma once

#include <exception>

class StdException : public std::exception {
  public:
    StdException() = default;
    explicit StdException(string const message) :
      message_(message)
      { }
    StdException(StdException const& std_exception) = default;
    StdException& operator=(StdException const&) = default;
    ~StdException() override = default;

    char const* what() const noexcept override
    { return message_.c_str(); }

    virtual string const& message() const noexcept
    { return message_; }

  private:
    string const message_;
}; // class StdException : public std::exception

/**
 ** An exception thrown when a reading (of data from an istream) failed
 **/
class ReadException : public StdException {
  public:
    ReadException() = default;
    explicit ReadException(string const message) :
      StdException(message)
      { }
    ReadException(ReadException const& exception) = default;
    ReadException& operator=(ReadException const&) = default;

    ~ReadException() override = default;
}; // class ReadException : public StdException
