/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 **********************************************************************/

#pragma once

enum class GameStatus {
  programstart = 0,
  quit = 1,
  party = 0x10,
  party_new = party,
  party_initial_loaded,
  party_loaded,
  party_play,
  party_finished,
  game = 0x100,
  game_new = game,
  game_init,
  game_reservation,
  game_redistribute,
  game_poverty_shift,
  game_start,
  game_play,
  game_full_trick,
  game_trick_taken,
  game_finished,
  game_closed
}; // enum class GameStatus

string to_string(GameStatus game_status) noexcept;
string gettext(GameStatus game_status);
ostream& operator<<(ostream& ostr, GameStatus game_status);

bool operator&(GameStatus lhs, GameStatus rhs);

bool in_running_game() noexcept;

extern GameStatus game_status;
