/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 **********************************************************************/

#pragma once

#include "exception.h"

enum class MarriageSelector {
  team_set,
  first_foreign,
  first_trump,
  first_color,
  first_club,
  first_spade,
  first_heart,
  silent
}; // enum class MarriageSelector
constexpr MarriageSelector marriage_selector_list[] = {
  MarriageSelector::team_set,
  MarriageSelector::first_foreign,
  MarriageSelector::first_trump,
  MarriageSelector::first_color,
  MarriageSelector::first_club,
  MarriageSelector::first_spade,
  MarriageSelector::first_heart,
  MarriageSelector::silent
};

string to_string(MarriageSelector marriage_selector) noexcept;
string gettext(MarriageSelector marriage_selector);
ostream& operator<<(ostream& ostr, MarriageSelector marriage_selector);
MarriageSelector marriage_selector_from_string(string const& name);
bool operator!(MarriageSelector marriage_selector) noexcept;
