/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 *********************************************************************/

#include "constants.h"

#include "game.h"

#include "../party/party.h"
#include "../party/rule.h"
#include "../ui/ui.h"
#include "../misc/setting.h"
#include "../player/human/human.h"

/** @return   the number of players
 **/
unsigned
Game::playerno() const
{
  return this->rule()(Rule::Type::number_of_players_in_game);
} // GamePlayers Game::players() const

/** @return   the players
 **/
GamePlayers const&
Game::players() const
{
  return *this->players_;
} // GamePlayers Game::players() const

/** @return   the players
 **/
GamePlayers&
Game::players()
{
  return *this->players_;
} // GamePlayers& Game::players()

/** @return   the players
 **/
GamePlayer const&
Game::player(unsigned p) const
{
  return this->players().player(p);
} // GamePlayer Game::player() const

/** @return   the players
 **/
GamePlayer&
Game::player(unsigned p)
{
  return this->players().player(p);
} // GamePlayer& Game::player()

/** @return   player whose has started the game
 **/
Player const&
Game::startplayer() const
{
  DEBUG_ASSERTION(this->startplayer_,
                  "Game::startplayer:\n"
                  "  this->startplayer_ == NULL");

  return *this->startplayer_;
} // Player const& Game::startplayer() const
