/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 **********************************************************************/

#pragma once

#include "base_player.h"
#include "../../card/card.h"

namespace GameplayActions {

/**
 ** base class for gameplay action of one player with cards
 ** t.i. there is one player who has initiated the action and it contains cards
 **/
template<Type type>
  struct BaseCards : public BasePlayer<type> {
      BaseCards() = default;
      BaseCards(unsigned playerno, vector<Card> cards);
      BaseCards(Player const& player, vector<Card> cards);
      explicit BaseCards(string const& line);

      ~BaseCards() override = default;

      bool equal(GameplayAction const& action) const override;

      void write(ostream& ostr) const override;

      string data_translation() const override;

      vector<Card> cards;
  }; // struct BaseCards : public BasePlayer<type>

} // namespace GameplayActions
#include "base_cards.hpp"
