/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 **********************************************************************/

#pragma once

#include "../basetypes.h"

struct Reservation {
    Reservation() = default;
    explicit Reservation(string const& line);
    ~Reservation() = default;;

    GameType game_type = GameType::normal;
    MarriageSelector marriage_selector = MarriageSelector::team_set;
    bool offer_duty_solo = false;
    bool swines = false;
    bool hyperswines = false;
}; // class Reservation

bool operator==(Reservation lhs, Reservation rhs) noexcept;
ostream& operator<<(ostream& ostr, Reservation const& reservation);
