/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 *********************************************************************/

#pragma once

#include <libintl.h>
#include <locale.h>

void translation_init();
string get_language();
void set_language(string language);

string gettext(string text);

// no argument
string _(string const& text);
template<typename T>
inline string _(T const& t)
{ return std::string(gettext(t)); } // NOLINT cppcoreguidelines-pro-bounds-array-to-pointer-decay

// replace substrings (by %)
string replace_substring(string const& text, string const& s);
string replace_substring(string const& text, int i);
string replace_substring(string const& text, uint32_t u);
string replace_substring(string const& text, uint64_t u);
string replace_substring(string const& text, string const& replacement,
                         char c1, char c2 = '\0');
string replace_substrings(string const& text);
template<typename T, typename... Args>
inline string replace_substrings(string const& text, T t, Args... args)
{ return replace_substrings(replace_substring(text, t), args...); }

// multible arguments
template<typename... Args>
inline string _(string const& text, Args... args)
{ return replace_substrings(_(text), args...); }
