/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more detai_dummyls. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 **********************************************************************/

#pragma once

#include "../player.h"
#include "../aiconfig.h"

/**
 ** dummy ai
 ** If the ai can win the trick, take the highest card,
 ** else take the lowest.
 **/
class AiDummy : public Player, public Aiconfig {
  public:
    AiDummy();
    explicit AiDummy(istream& istr);
    explicit AiDummy(Player const& player);
    AiDummy(Player const& player, Aiconfig const& aiconfig);
    AiDummy(AiDummy const& ai_dummy) = default;
    AiDummy& operator=(AiDummy const& ai_dummy) = default;
    unique_ptr<Player> clone() const override;

    ~AiDummy() override = default;

    Reservation const& reservation_get(bool duty_solo = false) override;
    HandCards poverty_shift() override;
    bool poverty_take_accept(unsigned cardno) override;
    HandCards poverty_cards_change(HandCards const& cards) override;
    void poverty_cards_get_back(HandCards const& cards) override;

    HandCard card_get() override;
    Announcement announcement_request() const override;
    Player const* genscher_partner() override;
}; // class AiDummy
