/**********************************************************************
 *
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License as
 *   published by the Free Software Foundation; either version 2 of
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 ********************************************************************/

#include "constants.h"

#include "call_function.h"

#include "../ai.h"
#include "../heuristic_interface.h"
#include "../../../card/trick.h"

/** constructor
 **/
Heuristic::CallFunction::CallFunction(Ai const& ai,
                                      Aiconfig::Heuristic const heuristic,
                                      Function const function) :
  Heuristic(ai, heuristic),
  function_(function)
{ }

/** destructor
 **/
Heuristic::CallFunction::~CallFunction() = default;

/** @return  card to play or empty card
 **/
Card
Heuristic::CallFunction::get_card(Trick const& trick)
{
  this->rationale_.clear();
  //this->rationale_.add(_("AiConfig::Heuristic::Description::" + to_string(this->heuristic())));
  return this->function_(trick, *this->ai_);
}
