/**********************************************************************
 *
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License as
 *   published by the Free Software Foundation; either version 2 of
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 ********************************************************************/

#include "constants.h"

#include "play_to_jab_later.h"

#include "../../../card/hand.h"
#include "../../../card/trick.h"
#include "../../../game/game.h"
#include "../../../party/rule.h"

/** constructor
 **/
Heuristic::PlayToJabLater::PlayToJabLater(Ai const& ai) :
  Heuristic(ai, Aiconfig::Heuristic::play_to_jab_later)
{ }

/** destructor
 **/
Heuristic::PlayToJabLater::~PlayToJabLater() = default;

/** @return  card to play or empty card
 **/
Card
Heuristic::PlayToJabLater::get_card(Trick const& trick)
{
  this->rationale_.clear();
  if (!(   this->condition_startcard(trick)
        && !this->condition_has_color()))
    return {};

  return {};

  auto const& game = trick.game();
  auto const& hand = this->hand();

  static auto const cards_to_play_with_nines
    = vector<Card>({Card::diamond_jack,
                   Card::heart_jack,
                   Card::diamond_nine,
                   Card::diamond_king});
  static auto const cards_to_play_without_nines
    = vector<Card>({Card::diamond_jack,
                   Card::heart_jack,
                   Card::diamond_king});

  auto const& cards_to_play
    = (   (game.rule()(Rule::Type::with_nines))
       ? cards_to_play_with_nines
       : cards_to_play_without_nines);

  // @heuristic::action      play a low trump
  for (auto const& c : cards_to_play) {
    if (   hand.contains(c)
        && !game.cards().is_special(HandCard(hand, c))) {
      this->rationale_.add(_("Heuristic::return::low trump - %s", _(c)));
      return c;
    }
  }

  this->rationale_.add(_("Heuristic::reject::no low trump in hand"));
  return Card::empty;
}

