/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 *********************************************************************/

#pragma once

#include "../heuristic.h"

/** Serve a trump trick the player cannot get
 **/
class Heuristic::ServeTrumpTrick : public Heuristic {
  public:
    explicit ServeTrumpTrick(Ai const& ai);
    ServeTrumpTrick(ServeTrumpTrick const&) = delete;
    ServeTrumpTrick& operator=(ServeTrumpTrick const&) = delete;

    ~ServeTrumpTrick() override;

    Card get_card(Trick const& trick) override;

  private:
    Card serve_with_trump(Trick const& trick);
    Card serve_with_color(Trick const& trick);
}; // class Heuristic::ServeTrumpTrick : public Heuristic
