/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 **********************************************************************/

#pragma once

#include "../card/trick.h"
#include "trickpile_iterator.h"
class Player;

/**
 ** The trickpile of a player
 **/
class TrickPile {
  friend class Player;
  public:
    using const_iterator = TrickPileConstIterator;

    TrickPile() = delete;
    explicit TrickPile(Player& player);
    TrickPile(TrickPile const& trickpile, Player& player);
    TrickPile(TrickPile const& trickpile) = delete;
    TrickPile& operator=(TrickPile const& trickpile);

    const_iterator begin() const;
    const_iterator end() const;

    bool empty() const;
    unsigned size() const;

    void clear();

    Trick& trick(unsigned p);
    Trick const& trick(unsigned p) const;
    Trick const& last_trick() const;

    void add(Trick const& trick);

  private:
    Player* const player_;
    vector<unsigned> tricks_;
}; // class TrickPile
