/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 *********************************************************************/

#include "constants.h"

#ifdef USE_UI_GTKMM

#include "ui.h"

#include "main_window.h"
#include "menu.h"
#include "party_summary.h"
#include "party_settings.h"
#include "players_db.h"
#include "players.h"
#include "rules.h"
#include "table.h"
#include "party_points.h"

#include "../../basetypes.h"
#include "../../party/party.h"

#include <gtkmm/main.h>

namespace UI_GTKMM_NS {

/** start a new party
 **/
void
  UI_GTKMM::start_new_party()
  {
    this->thrower(GameStatus::party_new, __FILE__, __LINE__);
    this->main_quit();
  } // void UI_GTKMM::start_new_party()

/** end a party
 **/
void
  UI_GTKMM::end_party()
  {
    this->thrower(GameStatus::party_finished, __FILE__, __LINE__);
    this->main_quit();
  } // void UI_GTKMM::end_party()

/** gets and sets the settings of the party:
 **   names, types and configuration of the players,
 **   rules,
 **   starting seed
 **   startplayer
 **/
void
  UI_GTKMM::party_get_settings()
  {
    this->party_summary->hide();
    this->party_settings->get();
  } // void UI_GTKMM::party_get_settings()

/** the party is loaded
 **/
void
  UI_GTKMM::party_loaded()
  {
    this->party_settings->hide();
    this->party_summary->party_loaded();
  } // void UI_GTKMM::party_loaded()


} // namespace UI_GTKMM_NS

#endif // #ifdef USE_UI_GTKMM
