/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 **********************************************************************/

#ifdef USE_UI_GTKMM

#pragma once

#include "../../basetypes.h"

#include <gdkmm/pixbuf.h>
#include <gdkmm/rgba.h>
namespace Gtk {
  class Widget;
  class ToggleButton;
  class Dialog;
  class Button;
} // namespace Gtk
namespace Gdk {
using Bitmap = Pixbuf;
using Pixmap = Pixbuf;
} // namespace Gdk
namespace UI_GTKMM_NS {
class UI_GTKMM;

// returns the name of the color
string colorname(Gdk::RGBA color);

#ifdef OUTDATED
// loads a pixbuf from the file and rotates it
vector<Glib::RefPtr<Gdk::Pixbuf> > load_pixbuf_with_rotations(string const& filename);
#endif // #ifdef OUTDATED

// returns the mask of the bitmap
Glib::RefPtr<Gdk::Bitmap> bitmap(Glib::RefPtr<Gdk::Pixbuf> pixbuf);

// toggle the view of 'widget' depending on the state of 'toggle_button'
void toggle_view(Gtk::Widget* widget,
                 Gtk::ToggleButton* toggle_button);
// sets the signal for 'toggle view'
void set_signal_toggle_view(Gtk::Widget* widget,
                            Gtk::ToggleButton* toggle_button);

// create a close button and pack it into the action area
template<typename T>
  Gtk::Button* add_close_button(T& dialog)
  { return add_close_button(*dialog.ui, dialog); }
Gtk::Button* add_close_button(UI_GTKMM& ui, Gtk::Dialog& dialog);
} // namespace UI_GTKMM_NS
#endif // #ifdef USE_UI_GTKMM
