/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 **********************************************************************/

#ifdef USE_UI_GTKMM

#pragma once

#include <gtkmm/filechooserdialog.h>

namespace Gtk {
/**
 ** a dialog which remembers its place and forwards the key presses
 ** (workaround)
 **/
class FileChooserDialogWrapper : public sigc::trackable {
  public:
    FileChooserDialogWrapper(Glib::ustring const& title,
                             Gtk::FileChooserAction action,
                             sigc::slot1<bool, string> slot);
    FileChooserDialogWrapper() = delete;
    FileChooserDialogWrapper(FileChooserDialogWrapper const&) = delete;
    FileChooserDialogWrapper& operator=(FileChooserDialogWrapper const&) = delete;

    ~FileChooserDialogWrapper();

    void set_current_folder(string dir);
    void set_title(string title);
    void present();

  protected:
    void init();
    void signal_ok();

  private:
    unique_ptr<FileChooserDialog> file_chooser_dialog_;
    Glib::ustring title_;
    Gtk::FileChooserAction const action_;
    sigc::slot1<bool, string> slot_;
    string current_folder_ = ".";
}; // class FileChooserDialogWrapper : public sigc::trackable

} // namespace Gtk

#endif // #ifdef USE_UI_GTKMM
