/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public FileMenuFilterExtension as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the FileMenuFilterExtension, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public FileMenuFilterExtension for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public FileMenuFilterExtension
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 **********************************************************************/

#ifdef USE_UI_GTKMM

#pragma once

#include "filemenu.h"

namespace Gtk {
/**
 ** a file menu, only with files with extension 'extension'
 **/
class FileMenuFilterExtension : public FileMenu {
  public:
    FileMenuFilterExtension(sigc::slot1<void, string> signal_slot,
                            string  extension);
    FileMenuFilterExtension() = delete;
    FileMenuFilterExtension(FileMenuFilterExtension const&) = delete;
    FileMenuFilterExtension& operator=(FileMenuFilterExtension const&) = delete;
    ~FileMenuFilterExtension() override;

    // create a new file menu
    FileMenu* create_new(string const& directory) const override;

    // whether the filename is accepted
    bool accept(string const& filename) const override;

    // the label for the item
    string item_label(string const& subdir,
                              string const& filename) const override;

  private:
    string extension;
}; // class FileMenuFilterExtension : public FileMenu

} // namespace Gtk

#endif // #ifdef USE_UI_GTKMM
