/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public Rules as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the Rules, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public Rules for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public Rules
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 **********************************************************************/

#include "constants.h"

#ifdef USE_UI_GTKMM

#include "labelscalespinbutton.h"

namespace Gtk {

/** constructor
 **/
LabelScaleSpinButton::LabelScaleSpinButton() :
  LabelScaleSpinButton("")
{  }

/** constructor
 **
 ** @param    label    name for the label
 **/
LabelScaleSpinButton::LabelScaleSpinButton(Glib::ustring const& label) :
  LabelSpinButton(label),
  scale_(Gtk::manage(new Gtk::Scale(Gtk::ORIENTATION_HORIZONTAL)))
{ 
  this->scale_->set_adjustment(this->spin_button_->get_adjustment());
  this->scale_->set_digits(0);
  this->scale_->set_draw_value(false);
  this->pack_end(*this->scale_, false, true);
} // LabelScaleSpinButton::LabelScaleSpinButton(Glib::ustring label)

/** @return   the scale
 **/
Scale*
LabelScaleSpinButton::get_scale()
{
  return this->scale_;
}

/** set the range
 **
 ** @param    min    minimum value
 ** @param    max    maximum value
 **/
void
LabelScaleSpinButton::set_range(double const min, double const max)
{ 
  this->scale_->set_range(min, max);
  this->scale_->set_size_request(static_cast<int>((max - min) * 10));
  this->LabelSpinButton::set_range(min, max);
} // void LabelScaleSpinButton::set_range(double min, double max)

} // namespace Gtk

#endif // #ifdef USE_UI_GTKMM
