/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 **********************************************************************/

#ifdef USE_UI_GTKMM

#pragma once

#include <gtkmm/dialog.h>

namespace UI_GTKMM_NS {
  class MainWindow;
} // namespace UI_GTKMM_NS
namespace Gtk {
/**
 ** a dialog which remembers its place and forwards the key presses
 ** (workaround)
 **/
class StickyDialog : public Dialog {
  public:
    StickyDialog(Glib::ustring const& title,
                 bool modal = false);
    StickyDialog(Glib::ustring const& title,
                 UI_GTKMM_NS::MainWindow& main_window,
                 bool modal = false);
    StickyDialog() = delete;
    StickyDialog(StickyDialog const&) = delete;
    StickyDialog& operator=(StickyDialog const&) = delete;

    ~StickyDialog() override = default;

  protected:
    bool on_key_press_event(GdkEventKey* key) override;
    void on_hide() override;
    void on_show() override;

  private:
    int x = INT_MAX;
    int y = INT_MAX;
    UI_GTKMM_NS::MainWindow* const main_window = nullptr;
}; // class StickyDialog : public Dialog

} // namespace Gtk

#endif // #ifdef USE_UI_GTKMM
