/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001 – 2018 by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public Rules as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the Rules, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public Rules for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public Rules
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@posteo.de
 *
 **********************************************************************/

#pragma once

#ifdef USE_UI_GTKMM

#include "constants.h"

#include "type_selector.h"

namespace Gtk {

/**
 ** adds the type to the selector
 **
 ** @param	type   type to be added
 **/
template<typename Type>
void
TypeSelector<Type>::add(Type const& type)
{
  this->append(_(type));
  this->types.push_back(type);

  return ;
} // void TypeSelector::add(Type type)

/**
 ** @return	the selected type
 **/
template<typename Type>
Type
TypeSelector<Type>::type()
{
  if (this->get_active_row_number() == -1)
    return {};
  return this->types[this->get_active_row_number()];
}

/**
 ** sets the selected type
 **
 ** @param	type	new selected type
 **/
template<typename Type>
void
TypeSelector<Type>::set_type(Type const& type)
{
  for (size_t i = 0; i < this->types.size(); ++i) {
    if (this->types[i] == type) {
      this->set_active(i);
      return ;
    }
  }

  DEBUG_ASSERTION(false,
		  "TypeSelector::set_type(" << type << ")\n"
		  << "  type not found");
  this->set_active(-1);
} // void TypeSelector<Type>::set_type(Type const& type)

} // namespace Gtk

#endif // #ifdef USE_UI_GTKMM
